config/routes.rb
Rails.application.routes.draw do

  # use_doorkeeper
  scope 'api' do
    use_doorkeeper do
      skip_controllers :authorizations, :applications, :authorized_applications
    end
  end

  mount Rswag::Ui::Engine => '/api-docs'
  mount Rswag::Api::Engine => '/api-docs'

  mount ProwhyApi::Api => '/api'

  scope '(:locale)', locale: /#{I18n.available_locales.join("|")}/ do
    # mount ProwhyApi::Api => '/api'

    # your routes here...
    namespace :labels do
      resources :cause_types
      get 'cause_types_list', to: 'cause_types#cause_types_list'
      post 'cause_types_list_set', to: 'cause_types#cause_types_list_set'
      resources :criteria
      resources :configs
      get 'config_add_criteria', to: 'configs#add_criteria'
      patch 'config_add_criteria_valid', to: 'configs#add_criteria_valid'
      get 'config_formula_test', to: 'configs#formula_test'
      resources :values
      resources :qqoqcp_lines
      resources :qqoqcp_configs
      get 'qqoqcp_config_add_line', to: 'qqoqcp_configs#add_line'
      patch 'qqoqcp_config_add_line_valid', to: 'qqoqcp_configs#add_line_valid'
      resources :check_list_elems
    end

    # scope module: 'tools' do
    namespace :tools do
      resources :qqoqcps
      resources :causes, only: [:new, :create, :edit, :update, :destroy]
      get 'cause_edit_status', to: 'causes#edit_status'
      resources :tasks
      resources :decision_mats
      # Cause Tree
      resources :cause_trees, only: [:index]
      get 'cause_trees_js_tree_data', to: 'cause_trees#cause_trees_js_tree_data'
      # Cause Tree => 5Why
      get 'cause_trees_index_5why', to: 'cause_trees#index_5why'
      # Ishikawa
      resources :ishikawas, only: [:index]
      get 'ishikawa_js_tree_data', to: 'ishikawas#ishikawa_js_tree_data'
      post 'ishikawa_drag_cause', to: 'ishikawas#ishikawa_drag_cause'
      get 'ishikawa_reset_branchs', to: 'ishikawas#ishikawa_reset_branchs'
      get 'ishikawa_zoom', to: 'ishikawas#ishikawa_zoom'
      post 'ishikawa_update_option', to: 'ishikawas#ishikawa_update_option'
      post 'save_canvas_to_png', to: 'ishikawas#save_canvas_to_png'
      post 'save_image', to: 'ishikawas#save_image'
      # Tasks
      get 'tasks_index_js', to: 'tasks#index_js'
      get 'tasks_export_pdf', to: 'tasks#export_pdf'
      get 'task_get_cause', to: 'tasks#task_get_cause'
      patch 'task_update_advance', to: 'tasks#update_advance'
      get 'tasks_send_emails', to: 'tasks#send_emails'
      post 'tasks_index_posts', to: 'tasks#index'
      get 'tasks_index_posts', to: 'tasks#index'

      get 'tasks_check_list', to: 'tasks#check_list'
      post 'tasks_check_list_valid', to: 'tasks#check_list_valid'

      get 'tasks_reschedule', to: 'tasks#reschedule'

      # Decision Mats
      # get 'decision_mat_open', to: 'decision_mats#open'
      patch 'decision_mat_save_values', to: 'decision_mats#save_values'
      delete 'decision_mat_delete_entry', to: 'decision_mats#delete_entry'
      get 'decision_mat_add_entry', to: 'decision_mats#add_entry'
      patch 'decision_mat_valid_entries', to: 'decision_mats#valid_entries'
      get 'decision_mat_add_criteria', to: 'decision_mats#add_criteria'
      patch 'decision_mat_valid_criteria', to: 'decision_mats#valid_criteria'
      # Teams
      resources :teams
      # Documents
      resources :documents
      # RcaRport
      resources :rca_reports, only: [:index]
      get 'rca_report_export', to: 'rca_reports#rca_report_export'
      get 'rca_report_comm', to: 'rca_reports#rca_report_comm'
      get 'rca_report_add_person', to: 'rca_reports#rca_report_add_person'
      get 'rca_report_add_person_do', to: 'rca_reports#rca_report_add_person_do'
      # Criticity
      resources :criticities
      patch 'criticity_calculate', to: 'criticities#calculate'
      # Images
      resources :images
      # Indicators
      resources :indicators
      post 'indicator_save_image', to: 'indicators#save_image'
      resources :indicator_measures
      patch 'indicator_measure_up', to: 'indicator_measures#indicator_measure_up'
      patch 'indicator_measure_down', to: 'indicator_measures#indicator_measure_down'
      # Check Efficacity
      resources :check_efficacity, only: [:index]
      get 'check_efficacity_edit_efficacity', to: 'check_efficacity#edit_efficacity'
      # Efficacity
      resources :efficacities
      # Generic
      resources :generics
      get 'generics_download_last_doc', to: 'generics#download_last_doc'
      # RcaList
      resources :rca_lists
    end

    namespace :meth do
      resources :tools
      resources :activities
      resources :list_contents # , only: [:index]
      resources :custom_field_descs
      resources :custom_field_types
      resources :steps
      resources :methodologies
      resources :step_tools
      resources :tool_custom_fields
      get 'step_tool_show', to: 'step_tools#step_tool_show'
      get 'step_tool_import', to: 'step_tools#step_tool_import'
      post 'step_tool_import_do', to: 'step_tools#step_tool_import_do'
      # Fonctions step à mettre dans des services
      get 'step_import', to: 'steps#step_import'
      post 'step_import_do', to: 'steps#step_import_do'
      get 'step_copy', to: 'steps#step_copy'
      post 'step_copy_do', to: 'steps#step_copy_do'
      delete 'step_del_tool', to: 'steps#step_del_tool'
      post 'step_add_tool', to: 'steps#step_add_tool'
      patch 'step_tool_up', to: 'steps#step_tool_up'
      patch 'step_tool_down', to: 'steps#step_tool_down'
      patch 'step_up', to: 'steps#step_up'
      patch 'step_down', to: 'steps#step_down'

      get 'tool_active', to: 'tool#tool_active'

      patch 'list_content_up', to: 'list_contents#list_content_up'
      patch 'list_content_down', to: 'list_contents#list_content_down'
      get 'list_content_new_from_csv', to: 'list_contents#new_from_csv'
      post 'list_content_create_from_csv', to: 'list_contents#create_from_csv'
      get 'list_content_export_csv', to: 'list_contents#export_csv'
      get 'list_content_export_save_csv', to: 'list_contents#export_save_csv'

      delete 'custom_field_desc_delete_all_list', to: 'custom_field_descs#delete_all_list'
      get 'custom_field_desc_dependant_fields_refresh', to: 'custom_field_descs#dependant_fields_refresh'
      get 'custom_field_desc_update_list_dependencies', to: 'custom_field_descs#update_list_dependencies'

      get 'show_tool_custom_field', to: 'tool_custom_fields#show_tool'
      patch 'tool_custom_field_up', to: 'tool_custom_fields#tool_custom_field_up'
      patch 'tool_custom_field_down', to: 'tool_custom_fields#tool_custom_field_down'

      get 'methodology_edit_meth', to: 'methodologies#edit_meth'
      post 'methodology_copy', to: 'methodologies#copy'

      # Tree Cntent for Custom fields
      resources :tree_contents
      get 'tree_contents_js_tree_data', to: 'tree_contents#js_tree_data'
    end

    namespace :admin do
      resources :admin_configs, only: [:index, :edit, :update]
      delete 'admin_config_delete_customer', to: 'admin_configs#delete_customer'
      resources :ldap_configs
      get 'ldap_config_test', to: 'ldap_configs#ldap_config_test'
      resources :perimeters
      get 'perimeters_assign_users', to: 'perimeters#assign_users'
      get 'perimeters_js_tree_data', to: 'perimeters#js_tree_data'
      patch 'perimeters_assign_users_valid', to: 'perimeters#assign_users_valid'
      resources :helper_texts
    end

    resources :custom_fields
    devise_for :users, controllers: { registrations: 'users/registrations',
                                      sessions: 'users/sessions' }
    devise_scope :user do
      get 'edit_user_preferences_registration', to: 'users/registrations#edit_preferences'
      patch 'update_user_preferences_registration', to: 'users/registrations#update_preferences'
    end
    resources :users_admin, controller: 'users', only: [:index, :new, :create, :edit, :update, :destroy]
    get 'users_admin_send_test_mail', to: 'users#send_test_mail'
    get 'users_admin_ldap_search', to: 'users#ldap_search'
    post 'users_admin_ldap_search_valid', to: 'users#ldap_search_valid'
    patch 'users_admin_update_pa_options', to: 'users#update_pa_options'
    resources :rcas
    patch 'rca_advancement_set', to: 'rcas#advancement_set'
    patch 'rca_reinit_all_advancements', to: 'rcas#reinit_all_advancements'
    get 'rca_closure', to: 'rcas#rca_closure'
    # patch 'rcas_search', to: 'rcas#rcas_search'
    patch 'rcas', to: 'rcas#index'
    patch 'rcas_reinit_filters_index', to: 'rcas#reinit_filters_index'
    get 'rcas_reinit_filters', to: 'rcas#reinit_filters'
    patch 'rcas_items_pp', to: 'rcas#rcas_items_pp'
    # get 'rcas_action_plan', to: 'rcas#rcas_action_plan'
    get 'rcas_assign_perimeters', to: 'rcas#assign_perimeters'
    patch 'rcas_assign_perimeters_valid', to: 'rcas#assign_perimeters_valid'
    get 'rca_recovery', to: 'rcas#recovery'
    patch 'rca_recovery_do', to: 'rcas#recovery_do'
    get 'rca_export_ods', to: 'rcas#export_ods'
    get 'rca_add_parent', to: 'rcas#rca_add_parent'
    patch 'rca_add_parent_valid', to: 'rcas#rca_add_parent_valid'
    delete 'rca_delete_parent', to: 'rcas#rca_delete_parent'

    resources :posts
    resources :tags, only: [:index, :show, :update]
    resources :admin, only: [:index]
    get 'admin_show_ahoy', to: 'admin#show_ahoy'
    resources :people
    get 'person_choose', to: 'people#person_choose'
    get 'person_choose_valid', to: 'people#person_choose_valid'
    resources :profils
    patch 'profil_raz_authorizations', to: 'profils#raz_authorizations'
    resources :profil_authorizes, only: [:index, :create, :update]
    resources :roles, only: [:index, :create]

    get 'tagged/:tag', to: 'posts#index', as: :tagged

    get 'tags_list', to: 'tags#tags_list'
    get 'tags_js_tree_data', to: 'tags#tags_js_tree_data'

    # get 'create_route_js', to: 'rcas#create_route_js'

    # get 'causes_js_tree_data', to: 'causes#causes_js_tree_data'

app/models/meth/tool.rb
require_dependency 'meth'

module Meth
  class Tool < ApplicationRecord
    include MethConcern

    translates :name, fallback: :any

    belongs_to :activity # , class_name: 'Meth::Activity'
    has_many :step_tools, dependent: :destroy
    has_many :steps, through: :step_tools

    validates :name, presence: true
    validates :tool_name, presence: true

    # serialize :tool_options
    def tool_options
      @tool_options ||= super&.deep_symbolize_keys!
    end

    after_initialize do
      if new_record?
        # Initialisation des tool_options
        self.tool_options ||= {}
      end
    end

    def self.find_or_create_custom_field
      return Tool.where(tool_name: 'CustomField').first || Tool.create!(name_fr: 'Champs personnalisés',
                                                                        name_en: 'Custom Fields',
                                                                        tool_name: 'CustomField',
                                                                        activity: Activity.find_or_create_infos)
    end

    def self.find_or_create_tool(options)
      return Tool.where(options).first || Tool.create!(name_fr: options[:tool_name].capitalize,
                                                       name_en: options[:tool_name].capitalize,
                                                       tool_name: options[:tool_name],
                                                       activity: Activity.find_or_create_infos)
    end
  end
end

app/models/tools/cause.rb
require_dependency 'tools'

module Tools
  class Cause < ApplicationRecord
    # has_ancestry
    include ToolModelConcern
    include AncestryConcern

    include ToolMatrixable

    enum status: { in_progress: 0, validated: 1, invalidated: 2 }, _prefix: true
    # enum level: { '0': 0, '-': -1, '--': -2, '+': 1, '++': 2 }, _prefix: true
    enum level: { '-': -1, '+': 1, '++': 2 }, _prefix: true
    # belongs_to :rca
    validates :name, presence: true
    validate :parent_from_same_rca

    before_save :name_valid_html

    # Liens vers les tools (tree & ishi) existent uniquement pour les Head Causes
    has_many :cause_links, dependent: :destroy # , foreign_key: :cause_id, class_name: 'Tools::CauseLink'
    # has_many :cause_tools, through: :cause_links

    # vérifier si on garde dependent destroy ou si on crée une fonction qui déconnecte l'action de la cause
    has_many :tools_tasks, foreign_key: :tools_cause_id, class_name: 'Tools::Task', dependent: :destroy

    # Lien vers les branches d'ishikawas
    has_many :tools_cause_classes, class_name: 'Tools::CauseClass', foreign_key: :tools_cause_id,
                                   dependent: :destroy, inverse_of: :tools_cause
    # inverse_of: :tools_cause => pour que le create fonctionne avec les nested attributes, sinon tool_cause_id est nul
    has_many :tools_ishikawas, class_name: 'Tools::Ishikawa', through: :tools_cause_classes
    has_many :labels_cause_types, class_name: 'Labels::CauseType', through: :tools_cause_classes

    accepts_nested_attributes_for :tools_cause_classes

    # options = { rca: rca, tool_reference: tool_reference }
    def self.create_default!(options, _step_tool)
      create!(options.except!(:tool_num).merge!(name: options[:rca].long_title, status: :validated))
    end

    def self.search_default(rca, tool_name, step_tool)
      return nil unless rca.send(tool_name) && step_tool

      return rca.send(tool_name).where(tool_reference: step_tool.tool_reference, ancestry: nil).first
    end

    # def tool_num
    #   1
    # end

    def name_with_level
      level.nil? ? name : "(#{level}) #{name}"
    end

    # Ishikawa => peut-être à mettre dans des services ?

    # return cause type id if cause is classed for this ishikawa
    def ishi_cause_type_id(ishikawa)
      tcc = tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
      return tcc&.labels_cause_type ? tcc.labels_cause_type_id : 0
    end

    def ishi_cause_type(ishikawa)
      tcc = tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
      return tcc ? tcc.labels_cause_type : nil
    end

    def ishi_cause_class(ishikawa)
      tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
    end

    def add_ishi_cause_type(ishikawa, ctype_id)
      if ctype_id == 0
        del_ishi_cause_type(ishikawa)
      else
        tcc = ishi_cause_class(ishikawa)

        if tcc
          tcc.labels_cause_type_id = ctype_id
          # del_ishi_cause_type(ishikawa) unless tcc.save
          begin
            tcc.save
          rescue StandardError
            del_ishi_cause_type(ishikawa)
          end
        else
          tcc = Tools::CauseClass.create!(tools_cause: self, tools_ishikawa: ishikawa, labels_cause_type_id: ctype_id)
        end
      end
      return tcc
    end

    def del_ishi_cause_type(ishikawa)
      tcc = ishi_cause_class(ishikawa)

      # tcc&.destroy
      tcc.labels_cause_type = nil
      tcc.save!
    end

    def update_cause_status_from_tasks
      tasks_v = tools_tasks.where(task_detail_type: 'Tools::TaskValidation')
      return if tasks_v.empty?

      new_status = 'invalidated'
      tools_tasks.where(task_detail_type: 'Tools::TaskValidation').each do |task_v|
        next unless task_v.task_detail

        case task_v.task_detail.status
        when 'in_progress'
          new_status = new_status == 'validated' ? 'validated' : 'in_progress'
        when 'validated'
          new_status = 'validated'
        when 'invalidated'
          new_status = new_status == 'invalidated' ? 'invalidated' : new_status
          # else
          #   puts 'PROBLEME DE TYPE DE STATUS ===============================>'.yellow
        end
      end
      update(status: new_status) unless new_status == status
    end

    def init_ishikawas_list
      ishikawas, ishikawa_names = rca.init_ishikawas_list_ref(tool_reference)

      return ishikawas, ishikawa_names
    end

    # A PRIORI INULTILES => A VOIR...

    # def init_ishikawas_cause_classes
    #   ishikawas, _ishikawa_names = rca.init_ishikawas_list
    #   ishikawas&.each do |ishikawa|
    #     init_ishikawa_cause_class(ishikawa)
    #   end
    # end

    # def init_ishikawa_cause_class(ishikawa)
    #   add_ishi_cause_type(ishikawa, nil)
    # end

    private

    def name_valid_html
      # puts "NAME".yellow
      # puts name.red
      name.gsub!(/([<>])/, ' \1 ')
      name.gsub!(/( +)/, ' ')
      # binding.pry
      # puts name.blue
    end

    def parent_from_same_rca
      return unless parent && rca && parent.rca != rca

      errors.add(:parent_id, 'Parent cause is not assigned to same rca as current cause.')
    end
  end
end

app/models/tools/cause_class.rb
require_dependency 'tools'

module Tools
  class CauseClass < ApplicationRecord
    belongs_to :tools_cause, class_name: 'Tools::Cause' # , inverse_of: :tools_cause_classes
    belongs_to :tools_ishikawa, class_name: 'Tools::Ishikawa'
    belongs_to :labels_cause_type, class_name: 'Labels::CauseType', optional: true

    # accepts_nested_attributes_for :labels_cause
  end
end

app/models/tools/cause_link.rb
require_dependency 'tools'

module Tools
  class CauseLink < ApplicationRecord
    belongs_to :cause # , class_name: 'Tools::Cause'
    belongs_to :cause_tool, polymorphic: true
  end
end

app/models/tools/crit_dec_mat.rb
require_dependency 'tools'

module Tools
  class CritDecMat < ApplicationRecord
    belongs_to :labels_criterium, class_name: 'Labels::Criterium'
    belongs_to :decision_mat # , class_name: 'Tools::DecisionMat'

    has_many :dec_mat_vals, dependent: :destroy
  end
end

app/models/tools/criticity_value.rb
require_dependency 'tools'

module Tools
  class CriticityValue < ApplicationRecord
    belongs_to :criticity
    belongs_to :labels_criterium, class_name: 'Labels::Criterium'
    belongs_to :labels_value, class_name: 'Labels::Value', optional: true
  end
end

app/views/tools/decision_mats/_add_criteria.html.erb
<div class="modal-header">
  <h5 class="modal-title" id="exampleModalLabel"><%= @modal_title.nil? ? "Decision Matrix" : @modal_title %></h5>
  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>

<%= form_with url: tools_decision_mat_valid_criteria_path, method: :patch do |form| %>
  <div class="modal-body">
    <%= hidden_field_tag 'id', tools_decision_mat.id %>

    <table>
      <% criteria.each do |crit| %>
        <tr>
          <td style='padding: 5px 15px;'><%= crit.name %></td>
          <td class='radio-item radio-item-valid'>
              <%= radio_button_tag "[dec_mat_crit][#{crit.id}]", 'true', tools_decision_mat.labels_criteria.include?(crit) ? true : false, class: 'radio dec-mat-radio radio-inprogress' %>
              <label for="_dec_mat_crit_<%=crit.id%>_true"></label>
          </td>
          <td class='radio-item radio-item-invalid'>
            <%= radio_button_tag "[dec_mat_crit][#{crit.id}]", 'false', tools_decision_mat.labels_criteria.include?(crit) ? false : true, class: 'radio dec-mat-radio radio-valid' %>
            <label for="_dec_mat_crit_<%=crit.id%>_false"></label>
          </td>

          <td style='padding: 5px 15px;'>
            <% weight = tools_decision_mat.labels_criteria.include?(crit) ? tools_decision_mat.crit_dec_mats.where(labels_criterium: crit).first.weight : 1 %>
            <label for="_dec_mat_weight_<%=crit.id%>">weight</label>
            <%= text_field_tag "[dec_mat_weight][#{crit.id}]", weight, size: 3 %>
          </td>
        </tr>
      <% end %>
    </table>
  </div>

  <div class="modal-footer">
    <div class="form-actions">
      <%= submit_tag 'Valid', class: 'btn btn-warning' %>
    </div>
  </div>
<% end %>

app/views/tools/decision_mats/_open.html.erb
<div id='tool-dec-mat-<%=@tools_decision_mat.id%>' class='dec-mat-open admin-col' dec-mat-id='<%=@tools_decision_mat.id%>'>

  <%= form_with url: tools_decision_mat_save_values_path, method: :patch do |form| %>
    <!-- ici ajout du submit caché pour que le click 'Enter' ne lance pas le vrai submit. Car 'Enter' lance le premier submit du form, qui ici ne fait rien.-->
    <button type="submit" disabled style="display: none" aria-hidden="true"></button>

    <h5>
      <button id='header-dec-mat-<%=@tools_decision_mat.id%>' class="btn collapsed" type="button" data-toggle="collapse" data-target="#dec-mat-<%=@tools_decision_mat.id%>" aria-expanded="false" aria-controls="dec-mat-<%=@tools_decision_mat.id%>" style='float:right;'>
        <%= fa_icon('caret-down') %>
      </button>

      <%= @tools_decision_mat.name %>
      <%= submit_tag t('.save'), class: 'btn btn-outline-dark', id: "dec-mat-submit-#{@tools_decision_mat.id}" %>
      &nbsp;&nbsp;
      <%= link_to fa_icon_edit, edit_tools_decision_mat_path(@tools_decision_mat), remote: true %>
      <%= link_to fa_icon_delete, @tools_decision_mat, method: :delete, data: { confirm: t('confirm.sure') } %>
    </h5>

    <div class="collapse-prowhy-ls show collapse multi-collapse" id='dec-mat-<%=@tools_decision_mat.id%>'>
      <%= hidden_field_tag 'id', @tools_decision_mat.id %>
      <%= hidden_field_tag "max-value-#{@tools_decision_mat.id}", @tools_decision_mat.max_value, class: 'dec-mat-max-value', 'dec-mat-id': @tools_decision_mat.id %>
      <table id='dec-mat-table'>
        <thead class='mat-title'>
          <tr class='dec-mat-crit first'>
            <th rowspan="2" colspan="2" class="mat-diag first">
              <div class="mat-diag-t1">
                <%= t('.criteria')%>
                <%= link_to fa_icon_edit, tools_decision_mat_add_criteria_path(id: @tools_decision_mat.id), remote: true %>
                <br/><%= t('.threshold') %><br/>
                <%= t('.weight') %>
              </div>
              <div class="mat-diag-t2">
                <%= t('.entries') %>
                <%= link_to fa_icon_edit, tools_decision_mat_add_entry_path(id: @tools_decision_mat.id), remote: true %>
              </div>
            </th>
            <% @tools_decision_mat.crit_dec_mats.includes([:labels_criterium]).each do |crit_dec_mat| %>
              <th colspan="2" style='padding: 0;'><%= crit_dec_mat.labels_criterium.name %>
                <br/>( >
                <span class='dec-mat-thresholds' crit-id='<%=crit_dec_mat.id%>' title='Seuil'>
                  <%= crit_dec_mat.labels_criterium.threshold %>
                </span>
                )
              </th>
            <% end %>
            <th rowspan="2">Total</th>
            <th colspan="3" class='last'><%= t('.valid') %> ?</th>
          </tr>
          <tr class='dec-mat-crit'>
            <% @tools_decision_mat.crit_dec_mats.each do |crit_dec_mat| %>
              <th colspan='2' class='dec-mat-weights' crit-id='<%=crit_dec_mat.id%>' title='Pondération'>
                <%= crit_dec_mat.weight %>
              </th>
              <!-- <th class='dec-mat-thresholds' crit-id='<%=crit_dec_mat.id%>' style='color:#f00;' title='Seuil'><%#= crit_dec_mat.labels_criterium.threshold #* crit_dec_mat.weight
              %></th> -->
            <% end %>

            <th class='mat-valid-title'>?</th>
            <th class='mat-valid-title'><%= t('.valid') %></th>
            <th class='mat-valid-title'><%= t('.not_valid') %></th>
          </tr>
        </thead>
        <tbody>
          <% @tools_decision_mat.dec_mat_links.includes(:entry).each do |dec_mat_link| %>
            <% entry = dec_mat_link.id %>
            <tr>
              <th colspan="2" class='mat-entry first-2'><%= dec_mat_link.entry.name %></th>

              <% @tools_decision_mat.crit_dec_mats.each do |crit_dec_mat| %>
                <% dec_mat_val = Tools::DecMatVal.where(dec_mat_link: dec_mat_link, crit_dec_mat: crit_dec_mat)&.first
                   # si pas trouvé => on le crée
                   dec_mat_val = @tools_decision_mat.add_val_link_crit(dec_mat_link, crit_dec_mat) unless dec_mat_val
                %>

                <td class='mat-value entry-<%=entry%>'>
                  <input name='[dec_mat_val][<%=dec_mat_val.id%>]' type="text" dec-mat-id='<%=@tools_decision_mat.id%>' dec-mat-entry-id='<%=entry%>' dec-mat-crit-id='<%=crit_dec_mat.id%>' dec-mat-tot-id='mat-value-tot-<%=dec_mat_val.id%>' class='dec-mat-val' value="<%= dec_mat_val.value %>" size="3">
                </td>
                <td id='mat-value-tot-<%=dec_mat_val.id%>' style='padding: 3px 10px'>-</td>
              <% end %>

              <td class='mat-total' dec-mat-entry-id='<%=entry%>'>
                -
              </td>

              <td class='mat-validation radio-item'>
                  <%= radio_button_tag "[dec_mat_checked][#{entry}]", 'in_progress', dec_mat_link.matrix_status_in_progress?, class: 'radio dec-mat-radio radio-inprogress', 'dec-mat-id': @tools_decision_mat.id %>
                  <label for="_dec_mat_checked_<%=entry%>_in_progress"></label>
              </td>
              <td class='mat-validation radio-item radio-item-valid'>
                <%= radio_button_tag "[dec_mat_checked][#{entry}]", 'validated', dec_mat_link.matrix_status_validated?, class: 'radio dec-mat-radio radio-valid', 'dec-mat-id': @tools_decision_mat.id %>
                <label for="_dec_mat_checked_<%=entry%>_validated"></label>
              </td>
              <td class='mat-validation radio-item radio-item-invalid'>
                <%= radio_button_tag "[dec_mat_checked][#{entry}]", 'invalidated', dec_mat_link.matrix_status_invalidated?, class: 'radio dec-mat-radio radio-invalid', 'dec-mat-id': @tools_decision_mat.id %>
                <label for="_dec_mat_checked_<%=entry%>_invalidated"></label>
              </td>
              <!-- <td class='dec-mat-icons'>
                <%#= link_to fa_icon_delete, tools_decision_mat_delete_entry_path(id: @tools_decision_mat.id, entry: entry), method: :delete %>
              </td> -->
              <% entry += 1 %>
            </tr>
          <% end %>
        </tbody>
      </table>
    </div>
  <% end %>
  <br>
</div>

app/views/tools/decision_mats/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @tools_decision_mat.name %>
</p>

<p>
  <strong>Entry class:</strong>
  <%= @tools_decision_mat.entry_class %>
</p>

<p>
  <strong>Tool reference:</strong>
  <%= @tools_decision_mat.tool_reference %>
</p>

<p>
  <strong>Tool num:</strong>
  <%= @tools_decision_mat.tool_num %>
</p>

<%= link_to 'Edit', edit_tools_decision_mat_path(@tools_decision_mat) %> |
<%= link_to t('back'), tools_decision_mats_path %>